// fait le 18-2-2001
// maxx@37.com
//
//
//ce composant permet de dessiner une ligne
//partant de (left, top) et suivant un vecteur
//(width, height).
//width et height peuvent etre negatifs
//
//ce composant a ete obtenu en modifiant la
//classe TShape

unit Line;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs;

type
  TLine = class(TGraphicControl)
  private
    FPen: TPen;
    function GetLineWidth: Integer;
    procedure SetLineWidth(Value: Integer);
    function GetColor: TColor;
    procedure SetColor(Value: TColor);
  protected
    procedure Paint; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    procedure StyleChanged(Sender: TObject);
    property Align;
    property Anchors;
    property DragCursor;
    property DragKind;
    property DragMode;
    property Enabled;
    property Constraints;
    property ParentShowHint;
    property LineWidth: Integer read GetLineWidth write SetLineWidth;
    property Color: TColor read GetColor write SetColor;
    property ShowHint;
    property Visible;
    property OnDragDrop;
    property OnDragOver;
    property OnEndDock;
    property OnEndDrag;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnStartDock;
    property OnStartDrag;
  end;

procedure Register;

implementation

constructor TLine.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := ControlStyle + [csReplicatable];
  Width := 65;
  Height := 65;
  FPen := TPen.Create;
  FPen.OnChange := StyleChanged;
end;

destructor TLine.Destroy;
begin
  FPen.Free;
  inherited Destroy;
end;

procedure TLine.Paint;
begin
  with Canvas do
  begin
    Pen := FPen;
    Moveto(0, 0);
    LineTo(Width, Height);
  end;
end;

procedure TLine.StyleChanged(Sender: TObject);
begin
  Invalidate;
end;

function TLine.GetLineWidth: Integer;
begin
  Result := FPen.Width;
end;

procedure TLine.SetLineWidth(Value: Integer);
begin
  if (FPen.Width <> Value) then
  begin
    FPen.Width := Value;
    Invalidate;
  end;
end;

function TLine.GetColor: TColor;
begin
  Result := FPen.Color;
end;

procedure Tline.SetColor(Value: TColor);
begin
  if (FPen.Color <> Value) then
  begin
    FPen.Color := Value;
    Invalidate;
  end;
end;

procedure Register;
begin
  RegisterComponents('Samples', [TLine]);
end;

end.

